use warnings;
use strict;
use Test::More tests => 12;
use Test::Exception;

use POWER::Utils;


# TODO check about "\r"

my ($none, @none, $in, $out, @in, @out, $expect);

# interface check

throws_ok { Chomp() } qr/usage: Chomp/;

($none) = Chomp('');
is($none, '',           "empty string, as list");

$none   = Chomp('');
is($none, '',           "empty string, as scalar");

$in     = "one line without CR";
($out)  = Chomp($in);
is($in, $out,           "one line without CR, as list");

$out    = Chomp($in);
is($in, $out,           "one line without CR, as scalar");

for (1..3) {
    @in     = (1 .. $_);
    @out    = Chomp(@in);
    is(@in, @out,           "list of $_ element(s)");
}

# logic check

$in     = "one line with CR\n";
$out    = Chomp($in);
$expect = "one line with CR";
is($out, $expect,           "one line with CR");

$in     = "one line with 2 CR\n\n";
$out    = Chomp($in);
$expect = "one line with 2 CR\n";
is($out, $expect,           "one line with 2 CR");

$in     = "two lines\nwith CR\n";
$out    = Chomp($in);
$expect = "two lines\nwith CR";
is($out, $expect,           "two lines with CR");

@in     = ("line1\n", "line2", "line3\n");
$out    = join "", Chomp(@in);
$expect = join "", ("line1", "line2", "line3");
is($out, $expect,           "array of lines with and without CR");

