use warnings;
use strict;
use Test::More tests => 7;
use Test::Exception;

use POWER::Utils;


my ($out, $plain, $wait);

throws_ok { EncUri() }      qr/usage: EncUri/;

$plain = 'Programming Perl';
$wait  = 'Programming+Perl';
$out    = EncUri($plain);
is($out, $wait,             "enc space");

$out    = UnEncUri($out);
is($out, $plain,            "unenc space");

$plain = "Programming Perl\n";
$wait  = 'Programming Perl%0A';
$out    = EncUri($plain, qr/[\n]/);
is($out, $wait,             "enc enter");

$out    = UnEncUri($out);
is($out, $plain,            "unenc enter");

$wait	= "Hello World";
$out	= UnEncUri("Hello%20World");
is($out, $wait,		    "unenc %20 to space");

$plain = join "", map {chr} 0 .. 0xFF;
$out   = UnEncUri(EncUri($plain));
is($out, $plain,	    "enc/unenc all ascii");

